#
# Conditional build:
%bcond_without	static_libs	# don't build static libraries
#
Summary:	Framewave - set of popular image and signal processing routines
Summary(pl.UTF-8):	Framewave - zestaw popularnych funkcji do przetwarzania obrazu i sygnału
Name:		framewave
Version:	1.3.1
Release:	14
License:	Apache v2.0
Group:		Libraries
Source0:	http://downloads.sourceforge.net/framewave/FRAMEWAVE_%{version}_SRC.tar.gz
# Source0-md5:	86a28ebfbfd70be06ab54d0d8b17ebd7
Patch0:		%{name}-system-boost.patch
Patch1:		%{name}-c++.patch
Patch2:		no-forced-arch-bits.patch
Patch3:		%{name}-templates.patch
Patch4:		%{name}-warnings.patch
Patch5:		%{name}-cpuid.patch
URL:		http://framewave.sourceforge.net/
BuildRequires:	boost-devel >= 1.34
BuildRequires:	libstdc++-devel
BuildRequires:	rpmbuild(macros) >= 1.385
BuildRequires:	scons
BuildRequires:	sed >= 4.0
ExclusiveArch:	%{ix86} %{x8664} x32
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Framewave(TM) is a collection of low-level software routines for x86
processors. Framewave (FW) is designed to aid and accelerate
application development, debugging, and optimization. Framewave
function capabilities extend from simple arithmetic operations to
rich, complex domain specific tasks, such as image, video, and signal
processing.

%description -l pl.UTF-8
Framewave(TM) to zestaw niskopoziomowych procedur dla procesorów x86.
Biblioteki zostały zaprojektowane tak, aby wspomóc i przyspieszyć
tworzenie aplikacji, diagnostykę i optymalizację. Możliwości funkcji
Framewave obejmują obszar od prostych operacji arytmetycznych po
złożone zadania specyficzne dla dziedziny, takie jak przetwarzanie
obrazu statycznego i ruchomego oraz sygnału.

%package devel
Summary:	Header files for Framewave libraries
Summary(pl.UTF-8):	Pliki nagłówkowe bibliotek Framewave
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Header files for Framewave libraries.

%description devel -l pl.UTF-8
Pliki nagłówkowe bibliotek Framewave.

%package static
Summary:	Static Framewave libraries
Summary(pl.UTF-8):	Statyczne biblioteki Framewave
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static Framewave libraries.

%description static -l pl.UTF-8
Statyczne biblioteki Framewave.

%prep
%setup -q -n FRAMEWAVE_%{version}_SRC
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

# kill precompiled binaries
%{__rm} BuildTools/bin/FwHeaderConvert_*

%{__sed} -i -e "s/'-O2'/'%{rpmcxxflags}'/" BuildTools/buildscripts/fwflags_gcc.py

%build
cd Framewave
mkdir -p build/{include,tmp,bin}
for kind in shared %{?with_static_libs:static} ; do
%scons \
%ifarch %{x8664} x32
	bitness=64 \
%else
	bitness=32 \
%endif
	libtype=$kind \
	variant=release
done

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_libdir},%{_includedir}}

cp -p Framewave/build/include/*.h $RPM_BUILD_ROOT%{_includedir}
install Framewave/build/bin/release_shared_*/lib*.so.*.*.* $RPM_BUILD_ROOT%{_libdir}
/sbin/ldconfig -n $RPM_BUILD_ROOT%{_libdir}
for f in $RPM_BUILD_ROOT%{_libdir}/lib*.so.*.*.* ; do
	ln -sf $(basename $f) $(echo $f | sed -e 's/[.0-9]*$//')
done
%if %{with static_libs}
install Framewave/build/bin/release_static_*/lib*.a $RPM_BUILD_ROOT%{_libdir}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc License.txt README
%attr(755,root,root) %{_libdir}/libfwBase.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libfwBase.so.1
%attr(755,root,root) %{_libdir}/libfwImage.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libfwImage.so.1
%attr(755,root,root) %{_libdir}/libfwJPEG.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libfwJPEG.so.1
%attr(755,root,root) %{_libdir}/libfwSignal.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libfwSignal.so.1
%attr(755,root,root) %{_libdir}/libfwVideo.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libfwVideo.so.1

%files devel
%defattr(644,root,root,755)
%doc Framewave/doc/*.h
%attr(755,root,root) %{_libdir}/libfwBase.so
%attr(755,root,root) %{_libdir}/libfwImage.so
%attr(755,root,root) %{_libdir}/libfwJPEG.so
%attr(755,root,root) %{_libdir}/libfwSignal.so
%attr(755,root,root) %{_libdir}/libfwVideo.so
%{_includedir}/fwBase.h
%{_includedir}/fwImage.h
%{_includedir}/fwImage_sol.h
%{_includedir}/fwJPEG.h
%{_includedir}/fwSignal.h
%{_includedir}/fwVideo.h

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libfwBase.a
%{_libdir}/libfwImage.a
%{_libdir}/libfwJPEG.a
%{_libdir}/libfwSignal.a
%{_libdir}/libfwVideo.a
%endif
%changelog
* Mon Oct 07 2019 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/framewave.git;a=log;h=master

* Mon Oct 07 2019 Jan Rękorajski <baggins@pld-linux.org> 2a9d8e7
- rebuild with boost 1.71
- release 14 (by relup.sh)

* Fri Apr 26 2019 Jakub Bogusz <qboosh@pld-linux.org> 4672362
- enhanced warnings patch; release 13

* Sat Apr 15 2017 Jakub Bogusz <qboosh@pld-linux.org> 2f0fee9
- enhanced c++ (cover also static_assert keyword, conflicting template arguments, new literals)
- added warnings patch (disable -Wnarrowing under gcc 6 in SSE vectors initialization hackery)
- added cpuid patch (replace custom asm code with GCC builtin, fixes build for x32 ABI)
- release 12

* Mon May 16 2016 Elan Ruusamäe <glen@delfi.ee> 68271a2
- icu-57.1 rebuild
- release 11 (by relup.sh)

* Tue Jan 26 2016 Jakub Bogusz <qboosh@pld-linux.org> 574f2b6
- added templates patch (use explicit instantiation, with gcc 5+ local usage seems to be inlined/optimized out)
- release 10

* Thu Dec 24 2015 Jakub Bogusz <qboosh@pld-linux.org> 25ef52d
- enhanced C++ patch (remove switch-bool warning, which prevented build with -Werror)

* Sun Jun 28 2015 Jan Rękorajski <baggins@pld-linux.org> fa97d39
- release 9 (by relup.sh)

* Sun Jun 28 2015 Jan Rękorajski <baggins@pld-linux.org> feac92f
- fix building on x32

* Wed Jun 10 2015 Jan Rękorajski <baggins@pld-linux.org> 594c6d6
- release 8 (by relup.sh)

* Mon Feb 16 2015 Jan Rękorajski <baggins@pld-linux.org> 3bc97bc
- rebuild with boost 1.57.0
- release 7 (by relup.sh)

* Sat Oct 25 2014 Jan Rękorajski <baggins@pld-linux.org> 073c2ae
- rebuild with boost 1.56.0
- release 6 (by relup.sh)

* Sun Feb 02 2014 Jan Rękorajski <baggins@pld-linux.org> efb51aa
- - rebuild with boost 1.55.0
- release 5 (by relup.sh)

* Sun Feb 02 2014 Jan Rękorajski <baggins@pld-linux.org> 094e48e
- - rebuild with boost 1.55.0
- release 4 (by relup.sh)

* Mon Jul 08 2013 Jan Rękorajski <baggins@pld-linux.org> 863a7c4
- release 3 (by relup.sh)

* Sun Jul 07 2013 Jan Rękorajski <baggins@pld-linux.org> a7d5602
- release 2 (by relup.sh)

* Fri Feb 22 2013 Jakub Bogusz <qboosh@pld-linux.org> 5663eee
- enhanced c++ patch to cover gcc 4.7

* Thu Feb 21 2013 Jakub Bogusz <qboosh@pld-linux.org> 20b8923
- finished system-boost patch (wrt. static libs build)

* Wed Feb 20 2013 Jakub Bogusz <qboosh@pld-linux.org> 7a3dd3a
- new
- system-boost patch to build with system boost libraries
- c++ patch to fix C++ violations prohibited by gcc 4.6+

